/**
 */
package de.mdelab.mlstorypatterns;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '
 * <em><b>Link Position Constraint Enum</b></em>', and utility methods for
 * working with them. <!-- end-user-doc -->
 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getLinkPositionConstraintEnum()
 * @model
 * @generated
 */
public enum LinkPositionConstraintEnum implements Enumerator {
	/**
	 * The '<em><b>UNCONSTRAINED</b></em>' literal object.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @see #UNCONSTRAINED_VALUE
	 * @generated
	 * @ordered
	 */
	UNCONSTRAINED(0, "UNCONSTRAINED", "UNCONSTRAINED"),

	/**
	 * The '<em><b>FIRST</b></em>' literal object.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #FIRST_VALUE
	 * @generated
	 * @ordered
	 */
	FIRST(1, "FIRST", "FIRST"),

	/**
	 * The '<em><b>LAST</b></em>' literal object.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #LAST_VALUE
	 * @generated
	 * @ordered
	 */
	LAST(2, "LAST", "LAST"),
	/**
	 * The '<em><b>BETWEEN</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BETWEEN_VALUE
	 * @generated
	 * @ordered
	 */
	BETWEEN(3, "BETWEEN", "BETWEEN");

	/**
	 * The '<em><b>UNCONSTRAINED</b></em>' literal value.
	 * <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of '<em><b>UNCONSTRAINED</b></em>' literal object isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #UNCONSTRAINED
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int UNCONSTRAINED_VALUE = 0;

	/**
	 * The '<em><b>FIRST</b></em>' literal value. <!-- begin-user-doc --> <!--
	 * end-user-doc --> <!-- begin-model-doc --> The target object of the link
	 * must be the first one in the ordered reference. <!-- end-model-doc -->
	 * 
	 * @see #FIRST
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int FIRST_VALUE = 1;

	/**
	 * The '<em><b>LAST</b></em>' literal value. <!-- begin-user-doc --> <!--
	 * end-user-doc --> <!-- begin-model-doc --> The target object of the link
	 * must be the last one in the ordered reference. <!-- end-model-doc -->
	 * 
	 * @see #LAST
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int LAST_VALUE = 2;

	/**
	 * The '<em><b>BETWEEN</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>BETWEEN</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #BETWEEN
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int BETWEEN_VALUE = 3;

	/**
	 * An array of all the '<em><b>Link Position Constraint Enum</b></em>' enumerators.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static final LinkPositionConstraintEnum[] VALUES_ARRAY = new LinkPositionConstraintEnum[]{
			UNCONSTRAINED, FIRST, LAST, BETWEEN,};

	/**
	 * A public read-only list of all the '
	 * <em><b>Link Position Constraint Enum</b></em>' enumerators. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final List<LinkPositionConstraintEnum> VALUES = Collections
			.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Link Position Constraint Enum</b></em>' literal with
	 * the specified literal value. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	public static LinkPositionConstraintEnum get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			LinkPositionConstraintEnum result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Link Position Constraint Enum</b></em>' literal with the specified name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static LinkPositionConstraintEnum getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			LinkPositionConstraintEnum result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Link Position Constraint Enum</b></em>' literal with
	 * the specified integer value. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	public static LinkPositionConstraintEnum get(int value) {
		switch (value) {
			case UNCONSTRAINED_VALUE :
				return UNCONSTRAINED;
			case FIRST_VALUE :
				return FIRST;
			case LAST_VALUE :
				return LAST;
			case BETWEEN_VALUE :
				return BETWEEN;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	private LinkPositionConstraintEnum(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int getValue() {
		return value;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getLiteral() {
		return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}

} // LinkPositionConstraintEnum
