package de.mdelab.mlstorypatterns.diagram.custom.edit.parts;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.expressiondialogs.Utility;
import de.mdelab.mlcallactions.CallAction;
import de.mdelab.mlcallactions.CallActionParameter;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlexpressions.MLStringExpression;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MLStringExpressionEditPart;

public class CustomMLStringExpressionEditPart extends MLStringExpressionEditPart implements IMLExpressionEditPart {

	public CustomMLStringExpressionEditPart(View view)
	{
		super(view);
	}

	/*
	 * should be similar to addNotationalListeners of:
	 * 
	 * CustomActivityEdgeGuardConstraintLabelEditPart
	 * CustomActivityFinalNodeReturnValueLabelEditPart
	 * CustomAttributeAssignmentEditPart CustomCallActionExpressionEditPart
	 * CustomCallActionExpression2EditPart CustomCallActionExpression3EditPart
	 * CustomStoryPatternExpressionLinkFeatureNameLabelEditPart
	 * CustomStoryPatternObjectClassifierLabelEditPart
	 */
//	@Override
//	protected void addNotationalListeners()
//	{
//		super.addNotationalListeners();
//		//MLExpression expr = ((AttributeAssignment) ((View) getModel()).getElement()).getAssignmentExpression();
//		//	JOptionPane.showInputDialog(expr + "ccd");
//		//EStructuralFeature feat = ((AttributeAssignment) ((View) getModel()).getElement()).getFeature();
//		
//		//this.addListenerFilter(Utility.getFilterId((MLNamedElement) feat), this, feat);
//		
//		//if (expr != null)
//		//{
//			//this.addListenerFilter(Utility.getFilterId((MLNamedElement) expr), this, expr);
////
//			/*if (expr instanceof CallActionExpression)
//			{
//				TreeIterator<EObject> it = ((CallActionExpression) expr).eAllContents();
//				for (EObject eObj; it.hasNext();)
//				{
//					eObj = it.next();
//					this.addListenerFilter(Utility.getFilterId((MLNamedElement) eObj), this, eObj);
//				}
//			}*/
//	//	}
//	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		updateFigure();
	}

	protected void updateFigure()
	{
		//EObject eO = ((View) getModel()).getElement();
		MLStringExpression expr = ((MLStringExpression) ((View) getModel()).getElement());//.getElement());

		String text = "[[ ]]";
		if (expr.getExpressionString()!=null){
			text ="[ " + expr.getExpressionString() + " ]";
		}
		setLabelText(text);
	}

	@Override
	protected void handleNotificationEvent(Notification event)
	{
		Object notifier = event.getNotifier();
		Object newValue = event.getNewValue();
		Object oldValue = event.getOldValue();
		int eventType = event.getEventType();

		if ((eventType == Notification.SET || eventType == Notification.ADD)
				&& (newValue instanceof CallAction || newValue instanceof MLExpression || newValue instanceof CallActionParameter))
		{
			// DB: Bug #1802
			this.addListenerFilter(Utility.getFilterId((EObject) newValue), this, (EObject) newValue);
			updateFigure();
		}
		else if (eventType == Notification.REMOVE
				&& (oldValue instanceof CallAction || oldValue instanceof MLExpression || oldValue instanceof CallActionParameter))
		{
			// DB: Bug #1802
			this.removeListenerFilter(Utility.getFilterId((EObject) oldValue));
			updateFigure();
		}
		else if (notifier instanceof AttributeAssignment || notifier instanceof CallAction || notifier instanceof MLExpression
				|| notifier instanceof CallActionParameter)
		{
			updateFigure();
		}

		super.handleNotificationEvent(event);
	}

	@Override
	public MLExpression getMLExpression() {
		return (MLExpression) getAdapter( MLExpression.class );
	}
}
