package de.mdelab.mlstorypatterns.diagram.custom.edit.parts;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.expressiondialogs.Utility;
import de.mdelab.mlstorypatterns.ContainmentLink;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.diagram.edit.parts.ContainmentLinkEditPart;

public class CustomStoryPatternContainmentLinkEditPart extends ContainmentLinkEditPart
{

	public CustomStoryPatternContainmentLinkEditPart(View view)
	{
		super(view);
	}

	@Override
	protected void handleNotificationEvent(Notification notification)
	{
		if (notification.getNotifier() instanceof ContainmentLink)
		{
			// Update colors if necessary ------------------------------------
			Utility.adaptColor(getPrimaryShape(), ((StoryPatternElement) ((View) this.getModel()).getElement()).getModifier());
		}

		super.handleNotificationEvent(notification);
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		Utility.adaptColor(getPrimaryShape(), ((StoryPatternElement) ((View) this.getModel()).getElement()).getModifier());
	}
}
