package de.mdelab.mlstorypatterns.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.StoryPatternLink;
import de.mdelab.mlstorypatterns.diagram.edit.policies.MlstorypatternsBaseItemSemanticEditPolicy;

/**
 * @generated
 */
public class LinkOrderConstraintReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public LinkOrderConstraintReorientCommand(
			ReorientRelationshipRequest request) {
		super(request.getLabel(), request.getRelationship(), request);
		reorientDirection = request.getDirection();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == getElementToEdit() instanceof LinkOrderConstraint) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof StoryPatternLink && newEnd instanceof StoryPatternLink)) {
			return false;
		}
		StoryPatternLink target = getLink().getSuccessorLink();
		if (!(getLink().eContainer() instanceof StoryPattern)) {
			return false;
		}
		StoryPattern container = (StoryPattern) getLink().eContainer();
		return MlstorypatternsBaseItemSemanticEditPolicy.getLinkConstraints()
				.canExistLinkOrderConstraint_4004(container, getLink(),
						getNewSource(), target);
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof StoryPatternLink && newEnd instanceof StoryPatternLink)) {
			return false;
		}
		StoryPatternLink source = getLink().getPredecessorLink();
		if (!(getLink().eContainer() instanceof StoryPattern)) {
			return false;
		}
		StoryPattern container = (StoryPattern) getLink().eContainer();
		return MlstorypatternsBaseItemSemanticEditPolicy.getLinkConstraints()
				.canExistLinkOrderConstraint_4004(container, getLink(), source,
						getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getLink().setPredecessorLink(getNewSource());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getLink().setSuccessorLink(getNewTarget());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected LinkOrderConstraint getLink() {
		return (LinkOrderConstraint) getElementToEdit();
	}

	/**
	 * @generated
	 */
	protected StoryPatternLink getOldSource() {
		return (StoryPatternLink) oldEnd;
	}

	/**
	 * @generated
	 */
	protected StoryPatternLink getNewSource() {
		return (StoryPatternLink) newEnd;
	}

	/**
	 * @generated
	 */
	protected StoryPatternLink getOldTarget() {
		return (StoryPatternLink) oldEnd;
	}

	/**
	 * @generated
	 */
	protected StoryPatternLink getNewTarget() {
		return (StoryPatternLink) newEnd;
	}
}
