package de.mdelab.mlstorypatterns.diagram.edit.parts;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.directedit.locator.CellEditorLocatorAccess;

import de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsVisualIDRegistry;

/**
 * @generated
 */
public class MlstorypatternsEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (MlstorypatternsVisualIDRegistry.getVisualID(view)) {

			case StoryPatternEditPart.VISUAL_ID:
				return new StoryPatternEditPart(view);

			case StoryPatternObjectEditPart.VISUAL_ID:
				return new StoryPatternObjectEditPart(view);

			case StoryPatternObjectNameEditPart.VISUAL_ID:
				return new StoryPatternObjectNameEditPart(view);

			case WrappingLabelEditPart.VISUAL_ID:
				return new WrappingLabelEditPart(view);

			case WrappingLabel2EditPart.VISUAL_ID:
				return new WrappingLabel2EditPart(view);

			case MLStringExpressionEditPart.VISUAL_ID:
				return new MLStringExpressionEditPart(view);

			case AttributeAssignmentEditPart.VISUAL_ID:
				return new AttributeAssignmentEditPart(view);

			case CallActionExpressionEditPart.VISUAL_ID:
				return new CallActionExpressionEditPart(view);

			case StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart.VISUAL_ID:
				return new StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart(
						view);

			case StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart.VISUAL_ID:
				return new StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart(
						view);

			case StoryPatternLinkEditPart.VISUAL_ID:
				return new StoryPatternLinkEditPart(view);

			case WrappingLabel3EditPart.VISUAL_ID:
				return new WrappingLabel3EditPart(view);

			case WrappingLabel4EditPart.VISUAL_ID:
				return new WrappingLabel4EditPart(view);

			case ContainmentLinkEditPart.VISUAL_ID:
				return new ContainmentLinkEditPart(view);

			case ExpressionLinkEditPart.VISUAL_ID:
				return new ExpressionLinkEditPart(view);

			case WrappingLabel5EditPart.VISUAL_ID:
				return new WrappingLabel5EditPart(view);

			case LinkOrderConstraintEditPart.VISUAL_ID:
				return new LinkOrderConstraintEditPart(view);

			case MapEntryLinkEditPart.VISUAL_ID:
				return new MapEntryLinkEditPart(view);

			case WrappingLabel6EditPart.VISUAL_ID:
				return new WrappingLabel6EditPart(view);

			case WrappingLabel7EditPart.VISUAL_ID:
				return new WrappingLabel7EditPart(view);

			case MapEntryLinkValueTargetEditPart.VISUAL_ID:
				return new MapEntryLinkValueTargetEditPart(view);

			case WrappingLabel8EditPart.VISUAL_ID:
				return new WrappingLabel8EditPart(view);

			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		return CellEditorLocatorAccess.INSTANCE
				.getTextCellEditorLocator(source);
	}
}
