package de.mdelab.mlstorypatterns.diagram.navigator;

import org.eclipse.gmf.runtime.common.ui.services.parser.CommonParserHint;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

import de.mdelab.mlcallactions.CallActionExpression;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.ContainmentLink;
import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.diagram.edit.parts.AttributeAssignmentEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.CallActionExpressionEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.ContainmentLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.ExpressionLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.LinkOrderConstraintEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MLStringExpressionEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MapEntryLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MapEntryLinkValueTargetEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternObjectNameEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel3EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel5EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel6EditPart;
import de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsDiagramEditorPlugin;
import de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsVisualIDRegistry;
import de.mdelab.mlstorypatterns.diagram.providers.MlstorypatternsElementTypes;
import de.mdelab.mlstorypatterns.diagram.providers.MlstorypatternsParserProvider;

/**
 * @generated
 */
public class MlstorypatternsNavigatorLabelProvider extends LabelProvider
		implements ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		MlstorypatternsDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		MlstorypatternsDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof MlstorypatternsNavigatorItem
				&& !isOwnView(((MlstorypatternsNavigatorItem) element)
						.getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof MlstorypatternsNavigatorGroup) {
			MlstorypatternsNavigatorGroup group = (MlstorypatternsNavigatorGroup) element;
			return MlstorypatternsDiagramEditorPlugin.getInstance()
					.getBundledImage(group.getIcon());
		}

		if (element instanceof MlstorypatternsNavigatorItem) {
			MlstorypatternsNavigatorItem navigatorItem = (MlstorypatternsNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (MlstorypatternsVisualIDRegistry.getVisualID(view)) {
		case ExpressionLinkEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.mdelab.de/mlstorypatterns/1.0?ExpressionLink", MlstorypatternsElementTypes.ExpressionLink_4003); //$NON-NLS-1$
		case MapEntryLinkValueTargetEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.mdelab.de/mlstorypatterns/1.0?MapEntryLink?valueTarget", MlstorypatternsElementTypes.MapEntryLinkValueTarget_4006); //$NON-NLS-1$
		case MLStringExpressionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.mdelab.de/mlexpressions/1.0?MLStringExpression", MlstorypatternsElementTypes.MLStringExpression_3001); //$NON-NLS-1$
		case StoryPatternLinkEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.mdelab.de/mlstorypatterns/1.0?StoryPatternLink", MlstorypatternsElementTypes.StoryPatternLink_4001); //$NON-NLS-1$
		case LinkOrderConstraintEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.mdelab.de/mlstorypatterns/1.0?LinkOrderConstraint", MlstorypatternsElementTypes.LinkOrderConstraint_4004); //$NON-NLS-1$
		case StoryPatternObjectEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.mdelab.de/mlstorypatterns/1.0?StoryPatternObject", MlstorypatternsElementTypes.StoryPatternObject_2003); //$NON-NLS-1$
		case CallActionExpressionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.mdelab.de/mlexpressions/mlcallactions/1.0?CallActionExpression", MlstorypatternsElementTypes.CallActionExpression_3003); //$NON-NLS-1$
		case AttributeAssignmentEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.mdelab.de/mlstorypatterns/1.0?AttributeAssignment", MlstorypatternsElementTypes.AttributeAssignment_3002); //$NON-NLS-1$
		case StoryPatternEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?http://www.mdelab.de/mlstorypatterns/1.0?StoryPattern", MlstorypatternsElementTypes.StoryPattern_1000); //$NON-NLS-1$
		case ContainmentLinkEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.mdelab.de/mlstorypatterns/1.0?ContainmentLink", MlstorypatternsElementTypes.ContainmentLink_4002); //$NON-NLS-1$
		case MapEntryLinkEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.mdelab.de/mlstorypatterns/1.0?MapEntryLink", MlstorypatternsElementTypes.MapEntryLink_4005); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = MlstorypatternsDiagramEditorPlugin
				.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& MlstorypatternsElementTypes.isKnownElementType(elementType)) {
			image = MlstorypatternsElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof MlstorypatternsNavigatorGroup) {
			MlstorypatternsNavigatorGroup group = (MlstorypatternsNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof MlstorypatternsNavigatorItem) {
			MlstorypatternsNavigatorItem navigatorItem = (MlstorypatternsNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (MlstorypatternsVisualIDRegistry.getVisualID(view)) {
		case ExpressionLinkEditPart.VISUAL_ID:
			return getExpressionLink_4003Text(view);
		case MapEntryLinkValueTargetEditPart.VISUAL_ID:
			return getMapEntryLinkValueTarget_4006Text(view);
		case MLStringExpressionEditPart.VISUAL_ID:
			return getMLStringExpression_3001Text(view);
		case StoryPatternLinkEditPart.VISUAL_ID:
			return getStoryPatternLink_4001Text(view);
		case LinkOrderConstraintEditPart.VISUAL_ID:
			return getLinkOrderConstraint_4004Text(view);
		case StoryPatternObjectEditPart.VISUAL_ID:
			return getStoryPatternObject_2003Text(view);
		case CallActionExpressionEditPart.VISUAL_ID:
			return getCallActionExpression_3003Text(view);
		case AttributeAssignmentEditPart.VISUAL_ID:
			return getAttributeAssignment_3002Text(view);
		case StoryPatternEditPart.VISUAL_ID:
			return getStoryPattern_1000Text(view);
		case ContainmentLinkEditPart.VISUAL_ID:
			return getContainmentLink_4002Text(view);
		case MapEntryLinkEditPart.VISUAL_ID:
			return getMapEntryLink_4005Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getContainmentLink_4002Text(View view) {
		ContainmentLink domainModelElement = (ContainmentLink) view
				.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getUuid();
		} else {
			MlstorypatternsDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 4002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getMapEntryLink_4005Text(View view) {
		IParser parser = MlstorypatternsParserProvider.getParser(
				MlstorypatternsElementTypes.MapEntryLink_4005, view
						.getElement() != null ? view.getElement() : view,
				MlstorypatternsVisualIDRegistry
						.getType(WrappingLabel6EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlstorypatternsDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getLinkOrderConstraint_4004Text(View view) {
		LinkOrderConstraint domainModelElement = (LinkOrderConstraint) view
				.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getUuid();
		} else {
			MlstorypatternsDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 4004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getAttributeAssignment_3002Text(View view) {
		IParser parser = MlstorypatternsParserProvider.getParser(
				MlstorypatternsElementTypes.AttributeAssignment_3002, view
						.getElement() != null ? view.getElement() : view,
				MlstorypatternsVisualIDRegistry
						.getType(AttributeAssignmentEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlstorypatternsDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 3002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getStoryPatternLink_4001Text(View view) {
		IParser parser = MlstorypatternsParserProvider.getParser(
				MlstorypatternsElementTypes.StoryPatternLink_4001, view
						.getElement() != null ? view.getElement() : view,
				MlstorypatternsVisualIDRegistry
						.getType(WrappingLabel3EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlstorypatternsDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getStoryPatternObject_2003Text(View view) {
		IParser parser = MlstorypatternsParserProvider.getParser(
				MlstorypatternsElementTypes.StoryPatternObject_2003, view
						.getElement() != null ? view.getElement() : view,
				MlstorypatternsVisualIDRegistry
						.getType(StoryPatternObjectNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlstorypatternsDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getCallActionExpression_3003Text(View view) {
		CallActionExpression domainModelElement = (CallActionExpression) view
				.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getUuid();
		} else {
			MlstorypatternsDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getStoryPattern_1000Text(View view) {
		StoryPattern domainModelElement = (StoryPattern) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getName();
		} else {
			MlstorypatternsDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 1000); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getMapEntryLinkValueTarget_4006Text(View view) {
		IParser parser = MlstorypatternsParserProvider.getParser(
				MlstorypatternsElementTypes.MapEntryLinkValueTarget_4006,
				view.getElement() != null ? view.getElement() : view,
				CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlstorypatternsDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6006); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getExpressionLink_4003Text(View view) {
		IParser parser = MlstorypatternsParserProvider.getParser(
				MlstorypatternsElementTypes.ExpressionLink_4003, view
						.getElement() != null ? view.getElement() : view,
				MlstorypatternsVisualIDRegistry
						.getType(WrappingLabel5EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlstorypatternsDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getMLStringExpression_3001Text(View view) {
		IParser parser = MlstorypatternsParserProvider.getParser(
				MlstorypatternsElementTypes.MLStringExpression_3001, view
						.getElement() != null ? view.getElement() : view,
				MlstorypatternsVisualIDRegistry
						.getType(MLStringExpressionEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlstorypatternsDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 3001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return StoryPatternEditPart.MODEL_ID
				.equals(MlstorypatternsVisualIDRegistry.getModelID(view));
	}

}
