/**
 */
package de.mdelab.mlstorypatterns.impl;

import java.util.Collection;

import java.util.Map;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.EnumerationLiteralId;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.utilities.ClassUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.LinkOrderConstraintEnum;
import de.mdelab.mlstorypatterns.LinkPositionConstraintEnum;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.MlstorypatternsTables;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.StoryPatternLink;
import java.lang.reflect.InvocationTargetException;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Link Order Constraint</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.LinkOrderConstraintImpl#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.LinkOrderConstraintImpl#getConstraintType <em>Constraint Type</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.LinkOrderConstraintImpl#getPredecessorLink <em>Predecessor Link</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.LinkOrderConstraintImpl#getSuccessorLink <em>Successor Link</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.LinkOrderConstraintImpl#getStoryPattern <em>Story Pattern</em>}</li>
 * </ul>
 *
 * @generated
 */
public class LinkOrderConstraintImpl extends MLElementWithUUIDImpl
		implements
			LinkOrderConstraint {
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation> annotations;

	/**
	 * The default value of the '{@link #getConstraintType() <em>Constraint Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getConstraintType()
	 * @generated
	 * @ordered
	 */
	protected static final LinkOrderConstraintEnum CONSTRAINT_TYPE_EDEFAULT = LinkOrderConstraintEnum.ANY_SUCCESSOR;

	/**
	 * The cached value of the '{@link #getConstraintType() <em>Constraint Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getConstraintType()
	 * @generated
	 * @ordered
	 */
	protected LinkOrderConstraintEnum constraintType = CONSTRAINT_TYPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getPredecessorLink() <em>Predecessor Link</em>}' reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getPredecessorLink()
	 * @generated
	 * @ordered
	 */
	protected StoryPatternLink predecessorLink;

	/**
	 * The cached value of the '{@link #getSuccessorLink() <em>Successor Link</em>}' reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getSuccessorLink()
	 * @generated
	 * @ordered
	 */
	protected StoryPatternLink successorLink;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected LinkOrderConstraintImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.LINK_ORDER_CONSTRAINT;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations() {
		if (annotations == null) {
			annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(
					MLAnnotation.class, this,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS,
					MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public LinkOrderConstraintEnum getConstraintType() {
		return constraintType;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setConstraintType(LinkOrderConstraintEnum newConstraintType) {
		LinkOrderConstraintEnum oldConstraintType = constraintType;
		constraintType = newConstraintType == null
				? CONSTRAINT_TYPE_EDEFAULT
				: newConstraintType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__CONSTRAINT_TYPE,
					oldConstraintType, constraintType));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPatternLink getPredecessorLink() {
		return predecessorLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPredecessorLink(
			StoryPatternLink newPredecessorLink, NotificationChain msgs) {
		StoryPatternLink oldPredecessorLink = predecessorLink;
		predecessorLink = newPredecessorLink;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK,
					oldPredecessorLink, newPredecessorLink);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setPredecessorLink(StoryPatternLink newPredecessorLink) {
		if (newPredecessorLink != predecessorLink) {
			NotificationChain msgs = null;
			if (predecessorLink != null)
				msgs = ((InternalEObject) predecessorLink).eInverseRemove(this,
						MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS,
						StoryPatternLink.class, msgs);
			if (newPredecessorLink != null)
				msgs = ((InternalEObject) newPredecessorLink).eInverseAdd(this,
						MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS,
						StoryPatternLink.class, msgs);
			msgs = basicSetPredecessorLink(newPredecessorLink, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK,
					newPredecessorLink, newPredecessorLink));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPatternLink getSuccessorLink() {
		return successorLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSuccessorLink(
			StoryPatternLink newSuccessorLink, NotificationChain msgs) {
		StoryPatternLink oldSuccessorLink = successorLink;
		successorLink = newSuccessorLink;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK,
					oldSuccessorLink, newSuccessorLink);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setSuccessorLink(StoryPatternLink newSuccessorLink) {
		if (newSuccessorLink != successorLink) {
			NotificationChain msgs = null;
			if (successorLink != null)
				msgs = ((InternalEObject) successorLink).eInverseRemove(this,
						MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS,
						StoryPatternLink.class, msgs);
			if (newSuccessorLink != null)
				msgs = ((InternalEObject) newSuccessorLink).eInverseAdd(this,
						MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS,
						StoryPatternLink.class, msgs);
			msgs = basicSetSuccessorLink(newSuccessorLink, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK,
					newSuccessorLink, newSuccessorLink));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPattern getStoryPattern() {
		if (eContainerFeatureID() != MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN)
			return null;
		return (StoryPattern) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStoryPattern(StoryPattern newStoryPattern,
			NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newStoryPattern,
				MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN,
				msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setStoryPattern(StoryPattern newStoryPattern) {
		if (newStoryPattern != eInternalContainer()
				|| (eContainerFeatureID() != MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN
						&& newStoryPattern != null)) {
			if (EcoreUtil.isAncestor(this, newStoryPattern))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newStoryPattern != null)
				msgs = ((InternalEObject) newStoryPattern).eInverseAdd(this,
						MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS,
						StoryPattern.class, msgs);
			msgs = basicSetStoryPattern(newStoryPattern, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN,
					newStoryPattern, newStoryPattern));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean LinkOrderConstraintPredecessorPosition(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv LinkOrderConstraintPredecessorPosition:
		 *   let
		 *     severity : Integer[1] = 'LinkOrderConstraint::LinkOrderConstraintPredecessorPosition'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.predecessorLink <> null implies self.predecessorLink.linkPositionConstraint <> LinkPositionConstraintEnum::LAST
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'The predecessor link of link order constraint ' +
		 *               self.toString() + ' may not have the position constraint \'LAST\'.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'LinkOrderConstraint::LinkOrderConstraintPredecessorPosition'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_LinkOrderConstraint_c_c_LinkOrderConstraintPredecessorPosition);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ StoryPatternLink predecessorLink = this
					.getPredecessorLink();
			final /*@NonInvalid*/ LinkPositionConstraintEnum linkPositionConstraint = predecessorLink
					.getLinkPositionConstraint();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_linkPositionConstraint = MlstorypatternsTables.ENUMid_LinkPositionConstraintEnum
					.getEnumerationLiteralId(ClassUtil
							.nonNullState(linkPositionConstraint.getName()));
			final /*@NonInvalid*/ boolean ne = BOXED_linkPositionConstraint != MlstorypatternsTables.ELITid_LAST;
			/*@NonInvalid*/ Boolean status;
			if (ne) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_The_32_predecessor_32_link_32_of_32_link_32_order_32_constraint_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_may_32_not_32_have_32_the_32_position_32_constraint_32_39_LAST_39_);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_LinkOrderConstraint_c_c_LinkOrderConstraintPredecessorPosition,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean LinkOrderConstraintSuccessor(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv LinkOrderConstraintSuccessor:
		 *   let
		 *     severity : Integer[1] = 'LinkOrderConstraint::LinkOrderConstraintSuccessor'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.successorLink <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Successor link of link order constraint ' +
		 *               self.toString() + ' must be specified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'LinkOrderConstraint::LinkOrderConstraintSuccessor'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_LinkOrderConstraint_c_c_LinkOrderConstraintSuccessor);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_0;
		if (le) {
			symbol_0 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_LinkOrderConstraint_c_c_LinkOrderConstraintSuccessor,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, ValueUtil.TRUE_VALUE,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_0 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean LinkOrderConstraintSuccessorPosition(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv LinkOrderConstraintSuccessorPosition:
		 *   let
		 *     severity : Integer[1] = 'LinkOrderConstraint::LinkOrderConstraintSuccessorPosition'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.successorLink <> null implies self.successorLink.linkPositionConstraint <> LinkPositionConstraintEnum::FIRST
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'The successor link of link order constraint ' +
		 *               self.toString() + ' may not have the position constraint \'FIRST\'.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'LinkOrderConstraint::LinkOrderConstraintSuccessorPosition'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_LinkOrderConstraint_c_c_LinkOrderConstraintSuccessorPosition);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ StoryPatternLink successorLink = this
					.getSuccessorLink();
			final /*@NonInvalid*/ LinkPositionConstraintEnum linkPositionConstraint = successorLink
					.getLinkPositionConstraint();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_linkPositionConstraint = MlstorypatternsTables.ENUMid_LinkPositionConstraintEnum
					.getEnumerationLiteralId(ClassUtil
							.nonNullState(linkPositionConstraint.getName()));
			final /*@NonInvalid*/ boolean ne = BOXED_linkPositionConstraint != MlstorypatternsTables.ELITid_FIRST;
			/*@NonInvalid*/ Boolean status;
			if (ne) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_The_32_successor_32_link_32_of_32_link_32_order_32_constraint_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_may_32_not_32_have_32_the_32_position_32_constraint_32_39_FIRST_39_);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_LinkOrderConstraint_c_c_LinkOrderConstraintSuccessorPosition,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean LinkOrderConstraintPredecessor(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv LinkOrderConstraintPredecessor:
		 *   let
		 *     severity : Integer[1] = 'LinkOrderConstraint::LinkOrderConstraintPredecessor'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.predecessorLink <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Predecessor link of link order constraint ' +
		 *               self.toString() + ' must be specified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'LinkOrderConstraint::LinkOrderConstraintPredecessor'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_LinkOrderConstraint_c_c_LinkOrderConstraintPredecessor);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_0;
		if (le) {
			symbol_0 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_LinkOrderConstraint_c_c_LinkOrderConstraintPredecessor,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, ValueUtil.TRUE_VALUE,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_0 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean LinkOrderConstraintPredecessorFeature(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv LinkOrderConstraintPredecessorFeature:
		 *   let
		 *     severity : Integer[1] = 'LinkOrderConstraint::LinkOrderConstraintPredecessorFeature'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.predecessorLink <> null and self.predecessorLink.feature <> null implies self.predecessorLink.feature.ordered and self.predecessorLink.feature.many
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'The feature of the predecessor link of link order constraint ' +
		 *               self.toString() + ' must be ordered and many-valued.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'LinkOrderConstraint::LinkOrderConstraintPredecessorFeature'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_LinkOrderConstraint_c_c_LinkOrderConstraintPredecessorFeature);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ StoryPatternLink predecessorLink_0 = this
					.getPredecessorLink();
			final /*@NonInvalid*/ EStructuralFeature feature_0 = predecessorLink_0
					.getFeature();
			final /*@NonInvalid*/ boolean ordered = feature_0.isOrdered();
			/*@NonInvalid*/ boolean and;
			if (ordered) {
				final /*@NonInvalid*/ boolean many = feature_0.isMany();
				and = many;
			} else {
				and = ValueUtil.FALSE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (and) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_The_32_feature_32_of_32_the_32_predecessor_32_link_32_of_32_link_32_order_32_constraint_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_be_32_ordered_32_and_32_many_m_valued);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_LinkOrderConstraint_c_c_LinkOrderConstraintPredecessorFeature,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean LinkOrderConstraintType(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv LinkOrderConstraintType:
		 *   let
		 *     severity : Integer[1] = 'LinkOrderConstraint::LinkOrderConstraintType'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.constraintType <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Constraint type of link order constraint ' +
		 *               self.toString() + ' must be specified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'LinkOrderConstraint::LinkOrderConstraintType'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_LinkOrderConstraint_c_c_LinkOrderConstraintType);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_0;
		if (le) {
			symbol_0 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_LinkOrderConstraint_c_c_LinkOrderConstraintType,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, ValueUtil.TRUE_VALUE,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_0 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean LinkOrderConstraintMatchingFeature(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv LinkOrderConstraintMatchingFeature:
		 *   let
		 *     severity : Integer[1] = 'LinkOrderConstraint::LinkOrderConstraintMatchingFeature'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.predecessorLink <> null and self.successorLink <> null implies self.predecessorLink.feature = self.successorLink.feature
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'The features of the predecessor and successor link of link order constraint ' +
		 *               self.toString() + ' must be the same.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'LinkOrderConstraint::LinkOrderConstraintMatchingFeature'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_LinkOrderConstraint_c_c_LinkOrderConstraintMatchingFeature);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ StoryPatternLink predecessorLink = this
					.getPredecessorLink();
			final /*@NonInvalid*/ EStructuralFeature feature = predecessorLink
					.getFeature();
			final /*@NonInvalid*/ StoryPatternLink successorLink = this
					.getSuccessorLink();
			final /*@NonInvalid*/ EStructuralFeature feature_0 = successorLink
					.getFeature();
			final /*@NonInvalid*/ boolean eq = feature.equals(feature_0);
			/*@NonInvalid*/ Boolean status;
			if (eq) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_The_32_features_32_of_32_the_32_predecessor_32_and_32_successor_32_link_32_of_32_link_32_order,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_be_32_the_32_same);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_LinkOrderConstraint_c_c_LinkOrderConstraintMatchingFeature,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getAnnotations())
						.basicAdd(otherEnd, msgs);
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK :
				if (predecessorLink != null)
					msgs = ((InternalEObject) predecessorLink).eInverseRemove(
							this,
							MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS,
							StoryPatternLink.class, msgs);
				return basicSetPredecessorLink((StoryPatternLink) otherEnd,
						msgs);
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK :
				if (successorLink != null)
					msgs = ((InternalEObject) successorLink).eInverseRemove(
							this,
							MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS,
							StoryPatternLink.class, msgs);
				return basicSetSuccessorLink((StoryPatternLink) otherEnd, msgs);
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN :
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetStoryPattern((StoryPattern) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS :
				return ((InternalEList<?>) getAnnotations())
						.basicRemove(otherEnd, msgs);
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK :
				return basicSetPredecessorLink(null, msgs);
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK :
				return basicSetSuccessorLink(null, msgs);
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN :
				return basicSetStoryPattern(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN :
				return eInternalContainer().eInverseRemove(this,
						MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS,
						StoryPattern.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS :
				return getAnnotations();
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__CONSTRAINT_TYPE :
				return getConstraintType();
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK :
				return getPredecessorLink();
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK :
				return getSuccessorLink();
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN :
				return getStoryPattern();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS :
				getAnnotations().clear();
				getAnnotations()
						.addAll((Collection<? extends MLAnnotation>) newValue);
				return;
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__CONSTRAINT_TYPE :
				setConstraintType((LinkOrderConstraintEnum) newValue);
				return;
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK :
				setPredecessorLink((StoryPatternLink) newValue);
				return;
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK :
				setSuccessorLink((StoryPatternLink) newValue);
				return;
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN :
				setStoryPattern((StoryPattern) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS :
				getAnnotations().clear();
				return;
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__CONSTRAINT_TYPE :
				setConstraintType(CONSTRAINT_TYPE_EDEFAULT);
				return;
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK :
				setPredecessorLink((StoryPatternLink) null);
				return;
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK :
				setSuccessorLink((StoryPatternLink) null);
				return;
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN :
				setStoryPattern((StoryPattern) null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS :
				return annotations != null && !annotations.isEmpty();
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__CONSTRAINT_TYPE :
				return constraintType != CONSTRAINT_TYPE_EDEFAULT;
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK :
				return predecessorLink != null;
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK :
				return successorLink != null;
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN :
				return getStoryPattern() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (derivedFeatureID) {
				case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS :
					return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
				default :
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS :
					return MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS;
				default :
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_PREDECESSOR_POSITION__DIAGNOSTICCHAIN_MAP :
				return LinkOrderConstraintPredecessorPosition(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_SUCCESSOR__DIAGNOSTICCHAIN_MAP :
				return LinkOrderConstraintSuccessor(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_SUCCESSOR_POSITION__DIAGNOSTICCHAIN_MAP :
				return LinkOrderConstraintSuccessorPosition(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_PREDECESSOR__DIAGNOSTICCHAIN_MAP :
				return LinkOrderConstraintPredecessor(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_PREDECESSOR_FEATURE__DIAGNOSTICCHAIN_MAP :
				return LinkOrderConstraintPredecessorFeature(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_TYPE__DIAGNOSTICCHAIN_MAP :
				return LinkOrderConstraintType(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT___LINK_ORDER_CONSTRAINT_MATCHING_FEATURE__DIAGNOSTICCHAIN_MAP :
				return LinkOrderConstraintMatchingFeature(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (constraintType: ");
		result.append(constraintType);
		result.append(')');
		return result.toString();
	}

} // LinkOrderConstraintImpl
