/**
 */
package de.mdelab.mlstorypatterns.impl;

import de.mdelab.mlstorypatterns.*;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;

import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.BindingTypeEnum;
import de.mdelab.mlstorypatterns.ContainmentLink;
import de.mdelab.mlstorypatterns.ExpressionLink;
import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.LinkOrderConstraintEnum;
import de.mdelab.mlstorypatterns.LinkPositionConstraintEnum;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.MatchTypeEnum;
import de.mdelab.mlstorypatterns.MlstorypatternsFactory;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.StoryPatternLink;
import de.mdelab.mlstorypatterns.StoryPatternObject;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Factory</b>. <!--
 * end-user-doc -->
 * @generated
 */
public class MlstorypatternsFactoryImpl extends EFactoryImpl
		implements
			MlstorypatternsFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public static MlstorypatternsFactory init() {
		try {
			MlstorypatternsFactory theMlstorypatternsFactory = (MlstorypatternsFactory) EPackage.Registry.INSTANCE
					.getEFactory(MlstorypatternsPackage.eNS_URI);
			if (theMlstorypatternsFactory != null) {
				return theMlstorypatternsFactory;
			}
		} catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new MlstorypatternsFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public MlstorypatternsFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case MlstorypatternsPackage.STORY_PATTERN :
				return createStoryPattern();
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT :
				return createStoryPatternObject();
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT :
				return createAttributeAssignment();
			case MlstorypatternsPackage.STORY_PATTERN_LINK :
				return createStoryPatternLink();
			case MlstorypatternsPackage.CONTAINMENT_LINK :
				return createContainmentLink();
			case MlstorypatternsPackage.EXPRESSION_LINK :
				return createExpressionLink();
			case MlstorypatternsPackage.MAP_ENTRY_LINK :
				return createMapEntryLink();
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT :
				return createLinkOrderConstraint();
			default :
				throw new IllegalArgumentException("The class '"
						+ eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case MlstorypatternsPackage.MODIFIER_ENUM :
				return createModifierEnumFromString(eDataType, initialValue);
			case MlstorypatternsPackage.MATCH_TYPE_ENUM :
				return createMatchTypeEnumFromString(eDataType, initialValue);
			case MlstorypatternsPackage.BINDING_TYPE_ENUM :
				return createBindingTypeEnumFromString(eDataType, initialValue);
			case MlstorypatternsPackage.LINK_POSITION_CONSTRAINT_ENUM :
				return createLinkPositionConstraintEnumFromString(eDataType,
						initialValue);
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT_ENUM :
				return createLinkOrderConstraintEnumFromString(eDataType,
						initialValue);
			default :
				throw new IllegalArgumentException("The datatype '"
						+ eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case MlstorypatternsPackage.MODIFIER_ENUM :
				return convertModifierEnumToString(eDataType, instanceValue);
			case MlstorypatternsPackage.MATCH_TYPE_ENUM :
				return convertMatchTypeEnumToString(eDataType, instanceValue);
			case MlstorypatternsPackage.BINDING_TYPE_ENUM :
				return convertBindingTypeEnumToString(eDataType, instanceValue);
			case MlstorypatternsPackage.LINK_POSITION_CONSTRAINT_ENUM :
				return convertLinkPositionConstraintEnumToString(eDataType,
						instanceValue);
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT_ENUM :
				return convertLinkOrderConstraintEnumToString(eDataType,
						instanceValue);
			default :
				throw new IllegalArgumentException("The datatype '"
						+ eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPattern createStoryPattern() {
		StoryPatternImpl storyPattern = new StoryPatternImpl();
		return storyPattern;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPatternObject createStoryPatternObject() {
		StoryPatternObjectImpl storyPatternObject = new StoryPatternObjectImpl();
		return storyPatternObject;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public AttributeAssignment createAttributeAssignment() {
		AttributeAssignmentImpl attributeAssignment = new AttributeAssignmentImpl();
		return attributeAssignment;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPatternLink createStoryPatternLink() {
		StoryPatternLinkImpl storyPatternLink = new StoryPatternLinkImpl();
		return storyPatternLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ContainmentLink createContainmentLink() {
		ContainmentLinkImpl containmentLink = new ContainmentLinkImpl();
		return containmentLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ExpressionLink createExpressionLink() {
		ExpressionLinkImpl expressionLink = new ExpressionLinkImpl();
		return expressionLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MapEntryLink createMapEntryLink() {
		MapEntryLinkImpl mapEntryLink = new MapEntryLinkImpl();
		return mapEntryLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public LinkOrderConstraint createLinkOrderConstraint() {
		LinkOrderConstraintImpl linkOrderConstraint = new LinkOrderConstraintImpl();
		return linkOrderConstraint;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public ModifierEnum createModifierEnumFromString(EDataType eDataType,
			String initialValue) {
		ModifierEnum result = ModifierEnum.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException("The value '" + initialValue
					+ "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String convertModifierEnumToString(EDataType eDataType,
			Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public MatchTypeEnum createMatchTypeEnumFromString(EDataType eDataType,
			String initialValue) {
		MatchTypeEnum result = MatchTypeEnum.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException("The value '" + initialValue
					+ "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String convertMatchTypeEnumToString(EDataType eDataType,
			Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public BindingTypeEnum createBindingTypeEnumFromString(EDataType eDataType,
			String initialValue) {
		BindingTypeEnum result = BindingTypeEnum.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException("The value '" + initialValue
					+ "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String convertBindingTypeEnumToString(EDataType eDataType,
			Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public LinkPositionConstraintEnum createLinkPositionConstraintEnumFromString(
			EDataType eDataType, String initialValue) {
		LinkPositionConstraintEnum result = LinkPositionConstraintEnum
				.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException("The value '" + initialValue
					+ "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String convertLinkPositionConstraintEnumToString(EDataType eDataType,
			Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public LinkOrderConstraintEnum createLinkOrderConstraintEnumFromString(
			EDataType eDataType, String initialValue) {
		LinkOrderConstraintEnum result = LinkOrderConstraintEnum
				.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException("The value '" + initialValue
					+ "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String convertLinkOrderConstraintEnumToString(EDataType eDataType,
			Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MlstorypatternsPackage getMlstorypatternsPackage() {
		return (MlstorypatternsPackage) getEPackage();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static MlstorypatternsPackage getPackage() {
		return MlstorypatternsPackage.eINSTANCE;
	}

} // MlstorypatternsFactoryImpl
