/**
 */
package de.mdelab.mlstorypatterns.impl;

import java.util.Collection;

import java.util.Map;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.EnumerationLiteralId;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.utilities.ClassUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlstorypatterns.MatchTypeEnum;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.MlstorypatternsTables;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import java.lang.reflect.InvocationTargetException;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Story Pattern Element</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternElementImpl#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternElementImpl#getModifier <em>Modifier</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternElementImpl#getMatchType <em>Match Type</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class StoryPatternElementImpl extends MLElementWithUUIDImpl
		implements
			StoryPatternElement {
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation> annotations;

	/**
	 * The default value of the '{@link #getModifier() <em>Modifier</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getModifier()
	 * @generated
	 * @ordered
	 */
	protected static final ModifierEnum MODIFIER_EDEFAULT = ModifierEnum.NONE;

	/**
	 * The cached value of the '{@link #getModifier() <em>Modifier</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getModifier()
	 * @generated
	 * @ordered
	 */
	protected ModifierEnum modifier = MODIFIER_EDEFAULT;

	/**
	 * The default value of the '{@link #getMatchType() <em>Match Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getMatchType()
	 * @generated
	 * @ordered
	 */
	protected static final MatchTypeEnum MATCH_TYPE_EDEFAULT = MatchTypeEnum.DEFAULT;

	/**
	 * The cached value of the '{@link #getMatchType() <em>Match Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getMatchType()
	 * @generated
	 * @ordered
	 */
	protected MatchTypeEnum matchType = MATCH_TYPE_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected StoryPatternElementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.STORY_PATTERN_ELEMENT;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations() {
		if (annotations == null) {
			annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(
					MLAnnotation.class, this,
					MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS,
					MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ModifierEnum getModifier() {
		return modifier;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setModifier(ModifierEnum newModifier) {
		ModifierEnum oldModifier = modifier;
		modifier = newModifier == null ? MODIFIER_EDEFAULT : newModifier;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MODIFIER,
					oldModifier, modifier));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MatchTypeEnum getMatchType() {
		return matchType;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMatchType(MatchTypeEnum newMatchType) {
		MatchTypeEnum oldMatchType = matchType;
		matchType = newMatchType == null ? MATCH_TYPE_EDEFAULT : newMatchType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MATCH_TYPE,
					oldMatchType, matchType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternElementOptional(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternElementOptional:
		 *   let
		 *     severity : Integer[1] = 'StoryPatternElement::StoryPatternElementOptional'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.matchType = MatchTypeEnum::OPTIONAL implies self.modifier = ModifierEnum::CREATE or self.modifier = ModifierEnum::DESTROY
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Optional story pattern element ' +
		 *               self.toString() + ' must be created or destroyed.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPatternElement::StoryPatternElementOptional'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPatternElement_c_c_StoryPatternElementOptional);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ MatchTypeEnum matchType = this.getMatchType();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_matchType = MlstorypatternsTables.ENUMid_MatchTypeEnum
					.getEnumerationLiteralId(
							ClassUtil.nonNullState(matchType.getName()));
			final /*@NonInvalid*/ boolean eq = BOXED_matchType == MlstorypatternsTables.ELITid_OPTIONAL;
			/*@NonInvalid*/ boolean implies;
			if (eq) {
				final /*@NonInvalid*/ ModifierEnum modifier_0 = this
						.getModifier();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier_0 = MlstorypatternsTables.ENUMid_ModifierEnum
						.getEnumerationLiteralId(
								ClassUtil.nonNullState(modifier_0.getName()));
				final /*@NonInvalid*/ boolean eq_0 = BOXED_modifier_0 == MlstorypatternsTables.ELITid_CREATE;
				/*@NonInvalid*/ boolean or;
				if (eq_0) {
					or = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ boolean eq_1 = BOXED_modifier_0 == MlstorypatternsTables.ELITid_DESTROY;
					or = eq_1;
				}
				implies = or;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Optional_32_story_32_pattern_32_element_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_be_32_created_32_or_32_destroyed);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPatternElement_c_c_StoryPatternElementOptional,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getAnnotations())
						.basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS :
				return ((InternalEList<?>) getAnnotations())
						.basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS :
				return getAnnotations();
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MODIFIER :
				return getModifier();
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MATCH_TYPE :
				return getMatchType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS :
				getAnnotations().clear();
				getAnnotations()
						.addAll((Collection<? extends MLAnnotation>) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MODIFIER :
				setModifier((ModifierEnum) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MATCH_TYPE :
				setMatchType((MatchTypeEnum) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS :
				getAnnotations().clear();
				return;
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MODIFIER :
				setModifier(MODIFIER_EDEFAULT);
				return;
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MATCH_TYPE :
				setMatchType(MATCH_TYPE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS :
				return annotations != null && !annotations.isEmpty();
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MODIFIER :
				return modifier != MODIFIER_EDEFAULT;
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MATCH_TYPE :
				return matchType != MATCH_TYPE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (derivedFeatureID) {
				case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS :
					return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
				default :
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS :
					return MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS;
				default :
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT___STORY_PATTERN_ELEMENT_OPTIONAL__DIAGNOSTICCHAIN_MAP :
				return StoryPatternElementOptional(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (modifier: ");
		result.append(modifier);
		result.append(", matchType: ");
		result.append(matchType);
		result.append(')');
		return result.toString();
	}

} // StoryPatternElementImpl
