/**
 */
package de.mdelab.mlstorypatterns.impl;

import java.util.Collection;

import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.EnumerationLiteralId;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanAndOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanImpliesOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanOrOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.messages.PivotMessages;
import org.eclipse.ocl.pivot.utilities.ClassUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.SetValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.BindingTypeEnum;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.MatchTypeEnum;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.MlstorypatternsTables;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.StoryPatternLink;
import de.mdelab.mlstorypatterns.StoryPatternObject;
import java.lang.reflect.InvocationTargetException;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Story Pattern Object</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternObjectImpl#getBindingType <em>Binding Type</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternObjectImpl#getConstraints <em>Constraints</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternObjectImpl#getAssignmentExpression <em>Assignment Expression</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternObjectImpl#getAttributeAssignments <em>Attribute Assignments</em>}</li>
 * </ul>
 *
 * @generated
 */
public class StoryPatternObjectImpl extends AbstractStoryPatternObjectImpl
		implements
			StoryPatternObject {
	/**
	 * The default value of the '{@link #getBindingType() <em>Binding Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getBindingType()
	 * @generated
	 * @ordered
	 */
	protected static final BindingTypeEnum BINDING_TYPE_EDEFAULT = BindingTypeEnum.UNBOUND;

	/**
	 * The cached value of the '{@link #getBindingType() <em>Binding Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getBindingType()
	 * @generated
	 * @ordered
	 */
	protected BindingTypeEnum bindingType = BINDING_TYPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getConstraints() <em>Constraints</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getConstraints()
	 * @generated
	 * @ordered
	 */
	protected EList<MLExpression> constraints;

	/**
	 * The cached value of the '{@link #getAssignmentExpression()
	 * <em>Assignment Expression</em>}' containment reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAssignmentExpression()
	 * @generated
	 * @ordered
	 */
	protected MLExpression assignmentExpression;

	/**
	 * The cached value of the '{@link #getAttributeAssignments()
	 * <em>Attribute Assignments</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAttributeAssignments()
	 * @generated
	 * @ordered
	 */
	protected EList<AttributeAssignment> attributeAssignments;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected StoryPatternObjectImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public BindingTypeEnum getBindingType() {
		return bindingType;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setBindingType(BindingTypeEnum newBindingType) {
		BindingTypeEnum oldBindingType = bindingType;
		bindingType = newBindingType == null
				? BINDING_TYPE_EDEFAULT
				: newBindingType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN_OBJECT__BINDING_TYPE,
					oldBindingType, bindingType));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLExpression> getConstraints() {
		if (constraints == null) {
			constraints = new EObjectContainmentEList<MLExpression>(
					MLExpression.class, this,
					MlstorypatternsPackage.STORY_PATTERN_OBJECT__CONSTRAINTS);
		}
		return constraints;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MLExpression getAssignmentExpression() {
		return assignmentExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetAssignmentExpression(
			MLExpression newAssignmentExpression, NotificationChain msgs) {
		MLExpression oldAssignmentExpression = assignmentExpression;
		assignmentExpression = newAssignmentExpression;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION,
					oldAssignmentExpression, newAssignmentExpression);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setAssignmentExpression(MLExpression newAssignmentExpression) {
		if (newAssignmentExpression != assignmentExpression) {
			NotificationChain msgs = null;
			if (assignmentExpression != null)
				msgs = ((InternalEObject) assignmentExpression).eInverseRemove(
						this,
						EOPPOSITE_FEATURE_BASE
								- MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION,
						null, msgs);
			if (newAssignmentExpression != null)
				msgs = ((InternalEObject) newAssignmentExpression).eInverseAdd(
						this,
						EOPPOSITE_FEATURE_BASE
								- MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION,
						null, msgs);
			msgs = basicSetAssignmentExpression(newAssignmentExpression, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION,
					newAssignmentExpression, newAssignmentExpression));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<AttributeAssignment> getAttributeAssignments() {
		if (attributeAssignments == null) {
			attributeAssignments = new EObjectContainmentWithInverseEList<AttributeAssignment>(
					AttributeAssignment.class, this,
					MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS,
					MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT);
		}
		return attributeAssignments;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternObjectAssignmentBound(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternObjectAssignmentBound:
		 *   let
		 *     severity : Integer[1] = 'StoryPatternObject::StoryPatternObjectAssignmentBound'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.assignmentExpression <> null implies self.bindingType = BindingTypeEnum::BOUND
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story pattern object ' +
		 *               self.toString() + ' with assignment expression must be bound.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPatternObject::StoryPatternObjectAssignmentBound'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPatternObject_c_c_StoryPatternObjectAssignmentBound);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ MLExpression assignmentExpression = this
					.getAssignmentExpression();
			final /*@NonInvalid*/ boolean ne = assignmentExpression != null;
			/*@NonInvalid*/ boolean implies;
			if (ne) {
				final /*@NonInvalid*/ BindingTypeEnum bindingType = this
						.getBindingType();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_bindingType = MlstorypatternsTables.ENUMid_BindingTypeEnum
						.getEnumerationLiteralId(
								ClassUtil.nonNullState(bindingType.getName()));
				final /*@NonInvalid*/ boolean eq = BOXED_bindingType == MlstorypatternsTables.ELITid_BOUND;
				implies = eq;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Story_32_pattern_32_object_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_with_32_assignment_32_expression_32_must_32_be_32_bound);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPatternObject_c_c_StoryPatternObjectAssignmentBound,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternObjectDataType(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternObjectDataType:
		 *   let
		 *     severity : Integer[1] = 'StoryPatternObject::StoryPatternObjectDataType'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if
		 *             self.type.oclIsKindOf(ecore::EDataType) implies
		 *             self.attributeAssignments->isEmpty()
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story pattern object ' +
		 *               self.toString() + ', whose type is an EDataType, may not have attribute assignments.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPatternObject::StoryPatternObjectDataType'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPatternObject_c_c_StoryPatternObjectDataType);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			/*@Caught*/ /*@NonNull*/ Object CAUGHT_oclIsKindOf;
			try {
				final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EDataType = idResolver
						.getClass(MlstorypatternsTables.CLSSid_EDataType, null);
				final /*@NonInvalid*/ EClassifier type = this.getType();
				final /*@Thrown*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
						.evaluate(executor, type, TYP_ecore_c_c_EDataType)
						.booleanValue();
				CAUGHT_oclIsKindOf = oclIsKindOf;
			} catch (Exception e) {
				CAUGHT_oclIsKindOf = ValueUtil.createInvalidValue(e);
			}
			final /*@NonInvalid*/ List<AttributeAssignment> attributeAssignments = this
					.getAttributeAssignments();
			final /*@NonInvalid*/ SetValue BOXED_attributeAssignments = idResolver
					.createSetOfAll(
							MlstorypatternsTables.SET_CLSSid_AttributeAssignment,
							attributeAssignments);
			final /*@NonInvalid*/ boolean isEmpty = CollectionIsEmptyOperation.INSTANCE
					.evaluate(BOXED_attributeAssignments).booleanValue();
			final /*@Thrown*/ Boolean implies = BooleanImpliesOperation.INSTANCE
					.evaluate(CAUGHT_oclIsKindOf, isEmpty);
			if (implies == null) {
				throw new InvalidValueException("Null if condition");
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Story_32_pattern_32_object_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__44_32_whose_32_type_32_is_32_an_32_EDataType_44_32_may_32_not_32_have_32_attribute_32_assignments);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPatternObject_c_c_StoryPatternObjectDataType,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternObjectIncomingLink(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternObjectIncomingLink:
		 *   let
		 *     severity : Integer[1] = 'StoryPatternObject::StoryPatternObjectIncomingLink'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.bindingType <> BindingTypeEnum::BOUND and self.modifier <> ModifierEnum::CREATE and self.matchType = MatchTypeEnum::DEFAULT implies
		 *             self.incomingLinks->exists(e | e.modifier <> null) or
		 *             self.outgoingLinks->exists(e | e.modifier <> ModifierEnum::CREATE and
		 *               (
		 *                 e.oclIsKindOf(ContainmentLink) or
		 *                 e.oclIsKindOf(StoryPatternLink) and
		 *                 e.oclAsType(StoryPatternLink)
		 *                 .feature.oclIsKindOf(ecore::EReference) and
		 *                 (
		 *                   e.oclAsType(StoryPatternLink)
		 *                   .feature.oclAsType(ecore::EReference).eOpposite <> null or
		 *                   e.oclAsType(StoryPatternLink)
		 *                   .feature.oclAsType(ecore::EReference).containment
		 *                 )
		 *               )) or
		 *             self.storyPattern.storyPatternLinks->exists(e |
		 *               e.oclIsKindOf(MapEntryLink) and
		 *               e.oclAsType(MapEntryLink).valueTarget = self)
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story pattern object ' +
		 *               self.toString() + ' must be reacheable from another object.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPatternObject::StoryPatternObjectIncomingLink'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPatternObject_c_c_StoryPatternObjectIncomingLink);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ BindingTypeEnum bindingType = this
					.getBindingType();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_bindingType = MlstorypatternsTables.ENUMid_BindingTypeEnum
					.getEnumerationLiteralId(
							ClassUtil.nonNullState(bindingType.getName()));
			final /*@NonInvalid*/ boolean ne = BOXED_bindingType != MlstorypatternsTables.ELITid_BOUND;
			/*@NonInvalid*/ boolean and;
			if (ne) {
				final /*@NonInvalid*/ ModifierEnum modifier = this
						.getModifier();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier = MlstorypatternsTables.ENUMid_ModifierEnum
						.getEnumerationLiteralId(
								ClassUtil.nonNullState(modifier.getName()));
				final /*@NonInvalid*/ boolean ne_0 = BOXED_modifier != MlstorypatternsTables.ELITid_CREATE;
				and = ne_0;
			} else {
				and = ValueUtil.FALSE_VALUE;
			}
			/*@NonInvalid*/ boolean and_0;
			if (and) {
				final /*@NonInvalid*/ MatchTypeEnum matchType = this
						.getMatchType();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_matchType = MlstorypatternsTables.ENUMid_MatchTypeEnum
						.getEnumerationLiteralId(
								ClassUtil.nonNullState(matchType.getName()));
				final /*@NonInvalid*/ boolean eq = BOXED_matchType == MlstorypatternsTables.ELITid_DEFAULT;
				and_0 = eq;
			} else {
				and_0 = ValueUtil.FALSE_VALUE;
			}
			/*@Thrown*/ Boolean implies;
			if (and_0) {
				/*@Caught*/ /*@Nullable*/ Object CAUGHT_or_1;
				try {
					final /*@NonInvalid*/ List<AbstractStoryPatternLink> incomingLinks = this
							.getIncomingLinks();
					final /*@NonInvalid*/ SetValue BOXED_incomingLinks = idResolver
							.createSetOfAll(
									MlstorypatternsTables.SET_CLSSid_AbstractStoryPatternLink,
									incomingLinks);
					/*@Thrown*/ Object accumulator = ValueUtil.FALSE_VALUE;
					/*@NonNull*/ Iterator<Object> ITERATOR_e_0 = BOXED_incomingLinks
							.iterator();
					/*@NonInvalid*/ Boolean exists;
					while (true) {
						if (!ITERATOR_e_0.hasNext()) {
							if (accumulator == ValueUtil.FALSE_VALUE) {
								exists = ValueUtil.FALSE_VALUE;
							} else {
								throw (InvalidValueException) accumulator;
							}
							break;
						}
						/*@NonInvalid*/ AbstractStoryPatternLink e_0 = (AbstractStoryPatternLink) ITERATOR_e_0
								.next();
						/**
						 * e.modifier <> null
						 */
						//
						exists = ValueUtil.TRUE_VALUE;
						break;
					}
					/*@Caught*/ /*@Nullable*/ Object CAUGHT_exists_0;
					try {
						final /*@NonInvalid*/ List<AbstractStoryPatternLink> outgoingLinks = this
								.getOutgoingLinks();
						final /*@NonInvalid*/ SetValue BOXED_outgoingLinks = idResolver
								.createSetOfAll(
										MlstorypatternsTables.SET_CLSSid_AbstractStoryPatternLink,
										outgoingLinks);
						/*@Thrown*/ Object accumulator_0 = ValueUtil.FALSE_VALUE;
						/*@NonNull*/ Iterator<Object> ITERATOR_e_1 = BOXED_outgoingLinks
								.iterator();
						/*@Thrown*/ Boolean exists_0;
						while (true) {
							if (!ITERATOR_e_1.hasNext()) {
								if (accumulator_0 == null) {
									exists_0 = null;
								} else if (accumulator_0 == ValueUtil.FALSE_VALUE) {
									exists_0 = ValueUtil.FALSE_VALUE;
								} else {
									throw (InvalidValueException) accumulator_0;
								}
								break;
							}
							/*@NonInvalid*/ AbstractStoryPatternLink e_1 = (AbstractStoryPatternLink) ITERATOR_e_1
									.next();
							/**
							 * e.modifier <> ModifierEnum::CREATE and
							 * (
							 *   e.oclIsKindOf(ContainmentLink) or
							 *   e.oclIsKindOf(StoryPatternLink) and
							 *   e.oclAsType(StoryPatternLink)
							 *   .feature.oclIsKindOf(ecore::EReference) and
							 *   (
							 *     e.oclAsType(StoryPatternLink)
							 *     .feature.oclAsType(ecore::EReference).eOpposite <> null or
							 *     e.oclAsType(StoryPatternLink)
							 *     .feature.oclAsType(ecore::EReference).containment
							 *   )
							 * )
							 */
							/*@Caught*/ /*@Nullable*/ Object CAUGHT_and_3;
							try {
								final /*@NonInvalid*/ ModifierEnum modifier_0 = e_1
										.getModifier();
								final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier_0 = MlstorypatternsTables.ENUMid_ModifierEnum
										.getEnumerationLiteralId(
												ClassUtil.nonNullState(
														modifier_0.getName()));
								final /*@NonInvalid*/ boolean ne_1 = BOXED_modifier_0 != MlstorypatternsTables.ELITid_CREATE;
								/*@Thrown*/ Boolean and_3;
								if (ne_1) {
									final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlstorypatterns_c_c_ContainmentLink = idResolver
											.getClass(
													MlstorypatternsTables.CLSSid_ContainmentLink,
													null);
									final /*@NonInvalid*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
											.evaluate(executor, e_1,
													TYP_mlstorypatterns_c_c_ContainmentLink)
											.booleanValue();
									/*@Thrown*/ Boolean or_0;
									if (oclIsKindOf) {
										or_0 = ValueUtil.TRUE_VALUE;
									} else {
										/*@Caught*/ /*@NonNull*/ Object CAUGHT_and_1;
										try {
											final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlstorypatterns_c_c_StoryPatternLink = idResolver
													.getClass(
															MlstorypatternsTables.CLSSid_StoryPatternLink,
															null);
											final /*@NonInvalid*/ boolean oclIsKindOf_0 = OclAnyOclIsKindOfOperation.INSTANCE
													.evaluate(executor, e_1,
															TYP_mlstorypatterns_c_c_StoryPatternLink)
													.booleanValue();
											/*@Thrown*/ boolean and_1;
											if (oclIsKindOf_0) {
												final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EReference = idResolver
														.getClass(
																MlstorypatternsTables.CLSSid_EReference,
																null);
												final /*@Thrown*/ StoryPatternLink oclAsType = ClassUtil
														.nonNullState(
																(StoryPatternLink) OclAnyOclAsTypeOperation.INSTANCE
																		.evaluate(
																				executor,
																				e_1,
																				TYP_mlstorypatterns_c_c_StoryPatternLink));
												final /*@Thrown*/ EStructuralFeature feature = oclAsType
														.getFeature();
												final /*@Thrown*/ boolean oclIsKindOf_1 = OclAnyOclIsKindOfOperation.INSTANCE
														.evaluate(executor,
																feature,
																TYP_ecore_c_c_EReference)
														.booleanValue();
												and_1 = oclIsKindOf_1;
											} else {
												and_1 = ValueUtil.FALSE_VALUE;
											}
											CAUGHT_and_1 = and_1;
										} catch (Exception e) {
											CAUGHT_and_1 = ValueUtil
													.createInvalidValue(e);
										}
										/*@Caught*/ /*@Nullable*/ Object CAUGHT_or;
										try {
											/*@Caught*/ /*@NonNull*/ Object CAUGHT_ne_2;
											try {
												final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EReference_0 = idResolver
														.getClass(
																MlstorypatternsTables.CLSSid_EReference,
																null);
												final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlstorypatterns_c_c_StoryPatternLink_1 = idResolver
														.getClass(
																MlstorypatternsTables.CLSSid_StoryPatternLink,
																null);
												final /*@Thrown*/ StoryPatternLink oclAsType_0 = ClassUtil
														.nonNullState(
																(StoryPatternLink) OclAnyOclAsTypeOperation.INSTANCE
																		.evaluate(
																				executor,
																				e_1,
																				TYP_mlstorypatterns_c_c_StoryPatternLink_1));
												final /*@Thrown*/ EStructuralFeature feature_0 = oclAsType_0
														.getFeature();
												final /*@Thrown*/ EReference oclAsType_1 = ClassUtil
														.nonNullState(
																(EReference) OclAnyOclAsTypeOperation.INSTANCE
																		.evaluate(
																				executor,
																				feature_0,
																				TYP_ecore_c_c_EReference_0));
												final /*@Thrown*/ EReference eOpposite = oclAsType_1
														.getEOpposite();
												final /*@Thrown*/ boolean ne_2 = eOpposite != null;
												CAUGHT_ne_2 = ne_2;
											} catch (Exception e) {
												CAUGHT_ne_2 = ValueUtil
														.createInvalidValue(e);
											}
											/*@Caught*/ /*@NonNull*/ Object CAUGHT_containment;
											try {
												final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EReference_1 = idResolver
														.getClass(
																MlstorypatternsTables.CLSSid_EReference,
																null);
												final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlstorypatterns_c_c_StoryPatternLink_2 = idResolver
														.getClass(
																MlstorypatternsTables.CLSSid_StoryPatternLink,
																null);
												final /*@Thrown*/ StoryPatternLink oclAsType_2 = ClassUtil
														.nonNullState(
																(StoryPatternLink) OclAnyOclAsTypeOperation.INSTANCE
																		.evaluate(
																				executor,
																				e_1,
																				TYP_mlstorypatterns_c_c_StoryPatternLink_2));
												final /*@Thrown*/ EStructuralFeature feature_1 = oclAsType_2
														.getFeature();
												final /*@Thrown*/ EReference oclAsType_3 = ClassUtil
														.nonNullState(
																(EReference) OclAnyOclAsTypeOperation.INSTANCE
																		.evaluate(
																				executor,
																				feature_1,
																				TYP_ecore_c_c_EReference_1));
												final /*@Thrown*/ boolean containment = oclAsType_3
														.isContainment();
												CAUGHT_containment = containment;
											} catch (Exception e) {
												CAUGHT_containment = ValueUtil
														.createInvalidValue(e);
											}
											final /*@Thrown*/ Boolean or = BooleanOrOperation.INSTANCE
													.evaluate(CAUGHT_ne_2,
															CAUGHT_containment);
											CAUGHT_or = or;
										} catch (Exception e) {
											CAUGHT_or = ValueUtil
													.createInvalidValue(e);
										}
										final /*@Thrown*/ Boolean and_2 = BooleanAndOperation.INSTANCE
												.evaluate(CAUGHT_and_1,
														CAUGHT_or);
										or_0 = and_2;
									}
									and_3 = or_0;
								} else {
									and_3 = ValueUtil.FALSE_VALUE;
								}
								CAUGHT_and_3 = and_3;
							} catch (Exception e) {
								CAUGHT_and_3 = ValueUtil.createInvalidValue(e);
							}
							//
							if (CAUGHT_and_3 == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
								exists_0 = ValueUtil.TRUE_VALUE;
								break; // Stop immediately
							} else if (CAUGHT_and_3 == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
								; // Carry on
							} else if (CAUGHT_and_3 == null) { // Abnormal null body evaluation result
								if (accumulator_0 == ValueUtil.FALSE_VALUE) {
									accumulator_0 = null; // Cache a null failure
								}
							} else if (CAUGHT_and_3 instanceof InvalidValueException) { // Abnormal exception evaluation result
								accumulator_0 = CAUGHT_and_3; // Cache an exception failure
							} else { // Impossible badly typed result
								accumulator_0 = new InvalidValueException(
										PivotMessages.NonBooleanBody, "exists");
							}
						}
						CAUGHT_exists_0 = exists_0;
					} catch (Exception e) {
						CAUGHT_exists_0 = ValueUtil.createInvalidValue(e);
					}
					final /*@Thrown*/ Boolean or_1 = BooleanOrOperation.INSTANCE
							.evaluate(exists, CAUGHT_exists_0);
					CAUGHT_or_1 = or_1;
				} catch (Exception e) {
					CAUGHT_or_1 = ValueUtil.createInvalidValue(e);
				}
				/*@Caught*/ /*@Nullable*/ Object CAUGHT_exists_1;
				try {
					final /*@NonInvalid*/ StoryPattern storyPattern = this
							.getStoryPattern();
					final /*@NonInvalid*/ List<AbstractStoryPatternLink> storyPatternLinks = storyPattern
							.getStoryPatternLinks();
					final /*@NonInvalid*/ SetValue BOXED_storyPatternLinks = idResolver
							.createSetOfAll(
									MlstorypatternsTables.SET_CLSSid_AbstractStoryPatternLink,
									storyPatternLinks);
					/*@Thrown*/ Object accumulator_1 = ValueUtil.FALSE_VALUE;
					/*@NonNull*/ Iterator<Object> ITERATOR_e_2 = BOXED_storyPatternLinks
							.iterator();
					/*@Thrown*/ Boolean exists_1;
					while (true) {
						if (!ITERATOR_e_2.hasNext()) {
							if (accumulator_1 == ValueUtil.FALSE_VALUE) {
								exists_1 = ValueUtil.FALSE_VALUE;
							} else {
								throw (InvalidValueException) accumulator_1;
							}
							break;
						}
						/*@NonInvalid*/ AbstractStoryPatternLink e_2 = (AbstractStoryPatternLink) ITERATOR_e_2
								.next();
						/**
						 *
						 * e.oclIsKindOf(MapEntryLink) and
						 * e.oclAsType(MapEntryLink).valueTarget = self
						 */
						/*@Caught*/ /*@NonNull*/ Object CAUGHT_and_4;
						try {
							final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlstorypatterns_c_c_MapEntryLink = idResolver
									.getClass(
											MlstorypatternsTables.CLSSid_MapEntryLink,
											null);
							final /*@NonInvalid*/ boolean oclIsKindOf_2 = OclAnyOclIsKindOfOperation.INSTANCE
									.evaluate(executor, e_2,
											TYP_mlstorypatterns_c_c_MapEntryLink)
									.booleanValue();
							/*@Thrown*/ boolean and_4;
							if (oclIsKindOf_2) {
								final /*@Thrown*/ MapEntryLink oclAsType_4 = ClassUtil
										.nonNullState(
												(MapEntryLink) OclAnyOclAsTypeOperation.INSTANCE
														.evaluate(executor, e_2,
																TYP_mlstorypatterns_c_c_MapEntryLink));
								final /*@Thrown*/ AbstractStoryPatternObject valueTarget = oclAsType_4
										.getValueTarget();
								final /*@Thrown*/ boolean eq_0 = this
										.equals(valueTarget);
								and_4 = eq_0;
							} else {
								and_4 = ValueUtil.FALSE_VALUE;
							}
							CAUGHT_and_4 = and_4;
						} catch (Exception e) {
							CAUGHT_and_4 = ValueUtil.createInvalidValue(e);
						}
						//
						if (CAUGHT_and_4 == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
							exists_1 = ValueUtil.TRUE_VALUE;
							break; // Stop immediately
						} else if (CAUGHT_and_4 == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
							; // Carry on
						} else if (CAUGHT_and_4 instanceof InvalidValueException) { // Abnormal exception evaluation result
							accumulator_1 = CAUGHT_and_4; // Cache an exception failure
						} else { // Impossible badly typed result
							accumulator_1 = new InvalidValueException(
									PivotMessages.NonBooleanBody, "exists");
						}
					}
					CAUGHT_exists_1 = exists_1;
				} catch (Exception e) {
					CAUGHT_exists_1 = ValueUtil.createInvalidValue(e);
				}
				final /*@Thrown*/ Boolean or_2 = BooleanOrOperation.INSTANCE
						.evaluate(CAUGHT_or_1, CAUGHT_exists_1);
				implies = or_2;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			if (implies == null) {
				throw new InvalidValueException("Null if condition");
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Story_32_pattern_32_object_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_be_32_reacheable_32_from_32_another_32_object);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPatternObject_c_c_StoryPatternObjectIncomingLink,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternObjectCreatedUnbound(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternObjectCreatedUnbound:
		 *   let
		 *     severity : Integer[1] = 'StoryPatternObject::StoryPatternObjectCreatedUnbound'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.modifier = ModifierEnum::CREATE implies self.bindingType = BindingTypeEnum::UNBOUND
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Created story pattern object ' +
		 *               self.toString() + ' must be unbound.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPatternObject::StoryPatternObjectCreatedUnbound'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPatternObject_c_c_StoryPatternObjectCreatedUnbound);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ ModifierEnum modifier = this.getModifier();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier = MlstorypatternsTables.ENUMid_ModifierEnum
					.getEnumerationLiteralId(
							ClassUtil.nonNullState(modifier.getName()));
			final /*@NonInvalid*/ boolean eq = BOXED_modifier == MlstorypatternsTables.ELITid_CREATE;
			/*@NonInvalid*/ boolean implies;
			if (eq) {
				final /*@NonInvalid*/ BindingTypeEnum bindingType = this
						.getBindingType();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_bindingType = MlstorypatternsTables.ENUMid_BindingTypeEnum
						.getEnumerationLiteralId(
								ClassUtil.nonNullState(bindingType.getName()));
				final /*@NonInvalid*/ boolean eq_0 = BOXED_bindingType == MlstorypatternsTables.ELITid_UNBOUND;
				implies = eq_0;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Created_32_story_32_pattern_32_object_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_must_32_be_32_unbound);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPatternObject_c_c_StoryPatternObjectCreatedUnbound,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternObjectCreatedConstraints(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternObjectCreatedConstraints:
		 *   let
		 *     severity : Integer[1] = 'StoryPatternObject::StoryPatternObjectCreatedConstraints'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.modifier = ModifierEnum::CREATE and self.matchType = MatchTypeEnum::DEFAULT implies
		 *             self.constraints->isEmpty()
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Created story pattern object ' +
		 *               self.toString() + ' may not have constraints.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPatternObject::StoryPatternObjectCreatedConstraints'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPatternObject_c_c_StoryPatternObjectCreatedConstraints);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ ModifierEnum modifier = this.getModifier();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier = MlstorypatternsTables.ENUMid_ModifierEnum
					.getEnumerationLiteralId(
							ClassUtil.nonNullState(modifier.getName()));
			final /*@NonInvalid*/ boolean eq = BOXED_modifier == MlstorypatternsTables.ELITid_CREATE;
			/*@NonInvalid*/ boolean and;
			if (eq) {
				final /*@NonInvalid*/ MatchTypeEnum matchType = this
						.getMatchType();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_matchType = MlstorypatternsTables.ENUMid_MatchTypeEnum
						.getEnumerationLiteralId(
								ClassUtil.nonNullState(matchType.getName()));
				final /*@NonInvalid*/ boolean eq_0 = BOXED_matchType == MlstorypatternsTables.ELITid_DEFAULT;
				and = eq_0;
			} else {
				and = ValueUtil.FALSE_VALUE;
			}
			/*@NonInvalid*/ boolean implies;
			if (and) {
				final /*@NonInvalid*/ List<MLExpression> constraints = this
						.getConstraints();
				final /*@NonInvalid*/ SetValue BOXED_constraints = idResolver
						.createSetOfAll(
								MlstorypatternsTables.SET_CLSSid_MLExpression,
								constraints);
				final /*@NonInvalid*/ boolean isEmpty = CollectionIsEmptyOperation.INSTANCE
						.evaluate(BOXED_constraints).booleanValue();
				implies = isEmpty;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Created_32_story_32_pattern_32_object_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_may_32_not_32_have_32_constraints);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPatternObject_c_c_StoryPatternObjectCreatedConstraints,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternObjectDestroyed(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternObjectDestroyed:
		 *   let
		 *     severity : Integer[1] = 'StoryPatternObject::StoryPatternObjectDestroyed'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.modifier = ModifierEnum::DESTROY implies
		 *             self.attributeAssignments->isEmpty()
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Destroyed story pattern object ' +
		 *               self.toString() + ' may not have attribute assignments.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPatternObject::StoryPatternObjectDestroyed'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPatternObject_c_c_StoryPatternObjectDestroyed);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ ModifierEnum modifier = this.getModifier();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_modifier = MlstorypatternsTables.ENUMid_ModifierEnum
					.getEnumerationLiteralId(
							ClassUtil.nonNullState(modifier.getName()));
			final /*@NonInvalid*/ boolean eq = BOXED_modifier == MlstorypatternsTables.ELITid_DESTROY;
			/*@NonInvalid*/ boolean implies;
			if (eq) {
				final /*@NonInvalid*/ List<AttributeAssignment> attributeAssignments = this
						.getAttributeAssignments();
				final /*@NonInvalid*/ SetValue BOXED_attributeAssignments = idResolver
						.createSetOfAll(
								MlstorypatternsTables.SET_CLSSid_AttributeAssignment,
								attributeAssignments);
				final /*@NonInvalid*/ boolean isEmpty = CollectionIsEmptyOperation.INSTANCE
						.evaluate(BOXED_attributeAssignments).booleanValue();
				implies = isEmpty;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Destroyed_32_story_32_pattern_32_object_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_may_32_not_32_have_32_attribute_32_assignments);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPatternObject_c_c_StoryPatternObjectDestroyed,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean StoryPatternObjectNACUnbound(
			final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternObjectNACUnbound:
		 *   let
		 *     severity : Integer[1] = 'StoryPatternObject::StoryPatternObjectNACUnbound'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.storyPattern.containingPattern <> null implies self.bindingType = BindingTypeEnum::UNBOUND
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story pattern object ' +
		 *               self.toString() + ' in a NAC must be unbound.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryPatternObject::StoryPatternObjectNACUnbound'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlstorypatternsTables.STR_StoryPatternObject_c_c_StoryPatternObjectNACUnbound);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlstorypatternsTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ StoryPattern storyPattern = this
					.getStoryPattern();
			final /*@NonInvalid*/ StoryPattern containingPattern = storyPattern
					.getContainingPattern();
			final /*@NonInvalid*/ boolean ne = containingPattern != null;
			/*@NonInvalid*/ boolean implies;
			if (ne) {
				final /*@NonInvalid*/ BindingTypeEnum bindingType = this
						.getBindingType();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_bindingType = MlstorypatternsTables.ENUMid_BindingTypeEnum
						.getEnumerationLiteralId(
								ClassUtil.nonNullState(bindingType.getName()));
				final /*@NonInvalid*/ boolean eq = BOXED_bindingType == MlstorypatternsTables.ELITid_UNBOUND;
				implies = eq;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlstorypatternsTables.STR_Story_32_pattern_32_object_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlstorypatternsTables.STR__32_in_32_a_32_NAC_32_must_32_be_32_unbound);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlstorypatternsTables.TUPLid_, sum_0,
								status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlstorypatternsTables.STR_StoryPatternObject_c_c_StoryPatternObjectNACUnbound,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlstorypatternsTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getAttributeAssignments())
						.basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__CONSTRAINTS :
				return ((InternalEList<?>) getConstraints())
						.basicRemove(otherEnd, msgs);
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION :
				return basicSetAssignmentExpression(null, msgs);
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS :
				return ((InternalEList<?>) getAttributeAssignments())
						.basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__BINDING_TYPE :
				return getBindingType();
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__CONSTRAINTS :
				return getConstraints();
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION :
				return getAssignmentExpression();
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS :
				return getAttributeAssignments();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__BINDING_TYPE :
				setBindingType((BindingTypeEnum) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__CONSTRAINTS :
				getConstraints().clear();
				getConstraints()
						.addAll((Collection<? extends MLExpression>) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION :
				setAssignmentExpression((MLExpression) newValue);
				return;
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS :
				getAttributeAssignments().clear();
				getAttributeAssignments().addAll(
						(Collection<? extends AttributeAssignment>) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__BINDING_TYPE :
				setBindingType(BINDING_TYPE_EDEFAULT);
				return;
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__CONSTRAINTS :
				getConstraints().clear();
				return;
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION :
				setAssignmentExpression((MLExpression) null);
				return;
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS :
				getAttributeAssignments().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__BINDING_TYPE :
				return bindingType != BINDING_TYPE_EDEFAULT;
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__CONSTRAINTS :
				return constraints != null && !constraints.isEmpty();
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION :
				return assignmentExpression != null;
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS :
				return attributeAssignments != null
						&& !attributeAssignments.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_ASSIGNMENT_BOUND__DIAGNOSTICCHAIN_MAP :
				return StoryPatternObjectAssignmentBound(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_DATA_TYPE__DIAGNOSTICCHAIN_MAP :
				return StoryPatternObjectDataType(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_INCOMING_LINK__DIAGNOSTICCHAIN_MAP :
				return StoryPatternObjectIncomingLink(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_CREATED_UNBOUND__DIAGNOSTICCHAIN_MAP :
				return StoryPatternObjectCreatedUnbound(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_CREATED_CONSTRAINTS__DIAGNOSTICCHAIN_MAP :
				return StoryPatternObjectCreatedConstraints(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_DESTROYED__DIAGNOSTICCHAIN_MAP :
				return StoryPatternObjectDestroyed(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT___STORY_PATTERN_OBJECT_NAC_UNBOUND__DIAGNOSTICCHAIN_MAP :
				return StoryPatternObjectNACUnbound(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (bindingType: ");
		result.append(bindingType);
		result.append(')');
		return result.toString();
	}

} // StoryPatternObjectImpl
