/**
 */
package de.mdelab.mlstorypatterns.provider;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.mdelab.mlannotations.MlannotationsFactory;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.provider.MLElementWithUUIDItemProvider;
import de.mdelab.mlexpressions.MlexpressionsFactory;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;

/**
 * This is the item provider adapter for a
 * {@link de.mdelab.mlstorypatterns.AttributeAssignment} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class AttributeAssignmentItemProvider
		extends
			MLElementWithUUIDItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public AttributeAssignmentItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addFeaturePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Feature feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	protected void addFeaturePropertyDescriptor(final Object object) {
		// itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory)
		// adapterFactory).getRootAdapterFactory(),
		// getResourceLocator(),
		// getString("_UI_AttributeAssignment_feature_feature"),
		// getString("_UI_PropertyDescriptor_description",
		// "_UI_AttributeAssignment_feature_feature",
		// "_UI_AttributeAssignment_type"),
		// MlstorypatternsPackage.Literals.ATTRIBUTE_ASSIGNMENT__FEATURE, true,
		// false, true, null, null, null));

		this.itemPropertyDescriptors.add(new ItemPropertyDescriptor(
				((ComposeableAdapterFactory) this.adapterFactory)
						.getRootAdapterFactory(),
				this.getResourceLocator(),
				this.getString("_UI_AttributeAssignment_feature_feature"),
				this.getString("_UI_PropertyDescriptor_description",
						"_UI_AttributeAssignment_feature_feature",
						"_UI_AttributeAssignment_type"),
				MlstorypatternsPackage.Literals.ATTRIBUTE_ASSIGNMENT__FEATURE,
				true, false, true, null, null, null) {

			@Override
			protected Collection<?> getComboBoxObjects(final Object object) {
				final AttributeAssignment assignment = (AttributeAssignment) object;

				if (assignment.getStoryPatternObject() != null
						&& assignment.getStoryPatternObject().getType() != null
						&& assignment.getStoryPatternObject()
								.getType() instanceof EClass) {
					return new ArrayList<Object>(
							((EClass) assignment.getStoryPatternObject()
									.getType()).getEAllStructuralFeatures());
				} else {
					return Collections.emptyList();
				}
			}
		});
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(
			Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(
					MlcorePackage.Literals.ML_ANNOTATED_ELEMENT__ANNOTATIONS);
			childrenFeatures.add(
					MlstorypatternsPackage.Literals.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns AttributeAssignment.gif.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator()
				.getImage("full/obj16/AttributeAssignment"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((AttributeAssignment) object).getUuid();
		return label == null || label.length() == 0
				? getString("_UI_AttributeAssignment_type")
				: getString("_UI_AttributeAssignment_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(AttributeAssignment.class)) {
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT :
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__FEATURE :
				fireNotifyChanged(new ViewerNotification(notification,
						notification.getNotifier(), false, true));
				return;
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS :
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION :
				fireNotifyChanged(new ViewerNotification(notification,
						notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(
			Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add(createChildParameter(
				MlcorePackage.Literals.ML_ANNOTATED_ELEMENT__ANNOTATIONS,
				MlannotationsFactory.eINSTANCE.createMLAnnotation()));

		newChildDescriptors.add(createChildParameter(
				MlstorypatternsPackage.Literals.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION,
				MlexpressionsFactory.eINSTANCE.createMLStringExpression()));
	}

}
