/**
 */
package de.mdelab.mlstorypatterns.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.EMFEditPlugin;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IItemFontProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.mdelab.mlexpressions.MlexpressionsFactory;
import de.mdelab.mlstorypatterns.MlstorypatternsFactory;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPatternObject;

/**
 * This is the item provider adapter for a
 * {@link de.mdelab.mlstorypatterns.StoryPatternObject} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class StoryPatternObjectItemProvider
		extends
			AbstractStoryPatternObjectItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public StoryPatternObjectItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addBindingTypePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Binding Type feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addBindingTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_StoryPatternObject_bindingType_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_StoryPatternObject_bindingType_feature",
						"_UI_StoryPatternObject_type"),
				MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT__BINDING_TYPE,
				true, false, false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				null, null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(
			Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(
					MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT__CONSTRAINTS);
			childrenFeatures.add(
					MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION);
			childrenFeatures.add(
					MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns StoryPatternObject.gif.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object,
				getResourceLocator().getImage("full/obj16/StoryPatternObject"));
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public String getText(final Object object) {
		String label = this.getString("_UI_StoryPatternObject_type") + " ";

		final StoryPatternObject spo = (StoryPatternObject) object;

		if (spo.getName() != null && !"".equals(spo.getName())) {
			label += spo.getName();
		} else {
			label += "[null]";
		}

		if (spo.getAssignmentExpression() != null) {
			label += " := ";

			final ComposedAdapterFactory factory = new ComposedAdapterFactory(
					EMFEditPlugin
							.getComposedAdapterFactoryDescriptorRegistry());

			label += ((IItemLabelProvider) factory.adapt(
					spo.getAssignmentExpression(), IItemLabelProvider.class))
							.getText(spo.getAssignmentExpression());
		}

		return label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(StoryPatternObject.class)) {
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__BINDING_TYPE :
				fireNotifyChanged(new ViewerNotification(notification,
						notification.getNotifier(), false, true));
				return;
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__CONSTRAINTS :
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION :
			case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS :
				fireNotifyChanged(new ViewerNotification(notification,
						notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(
			Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add(createChildParameter(
				MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT__CONSTRAINTS,
				MlexpressionsFactory.eINSTANCE.createMLStringExpression()));

		newChildDescriptors.add(createChildParameter(
				MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION,
				MlexpressionsFactory.eINSTANCE.createMLStringExpression()));

		newChildDescriptors.add(createChildParameter(
				MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS,
				MlstorypatternsFactory.eINSTANCE.createAttributeAssignment()));
	}

	/**
	 * This returns the label text for
	 * {@link org.eclipse.emf.edit.command.CreateChildCommand}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String getCreateChildText(Object owner, Object feature, Object child,
			Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify = childFeature == MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT__CONSTRAINTS
				|| childFeature == MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION;

		if (qualify) {
			return getString("_UI_CreateChild_text2",
					new Object[]{getTypeText(childObject),
							getFeatureText(childFeature), getTypeText(owner)});
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

	@Override
	public Object getFont(final Object object) {
		final StoryPatternObject spo = (StoryPatternObject) object;

		switch (spo.getBindingType()) {
			case UNBOUND :
				return IItemFontProvider.NORMAL_FONT;
			case BOUND :
				return IItemFontProvider.BOLD_FONT;
			case CAN_BE_BOUND :
				return IItemFontProvider.ITALIC_FONT;
			default :
				throw new UnsupportedOperationException();
		}
	}

}
